bl_info = \
	{
		"name" : "Damn Simple Tests",
		"author" : "jackie",
		"version" : (4, 1, 0),
		"blender" : (3, 0, 0),
		"description" : "woah",
		"category" : "Object Data",
	}

import bpy
from typing import List, Tuple

_need_reload = "operators" in locals()
from . import gui, operators, common

if _need_reload:
    import importlib

    gui = importlib.reload(gui)
    common = importlib.reload(common)
    operators = importlib.reload(operators)


# Register classes
#def register() -> None:
def register():
    from bpy.utils import register_class

    gui.register()
    operators.register()


# Unregister classes
def unregister() -> None:
    from bpy.utils import unregister_class

    gui.unregister()
    operators.unregister()

if __name__ == "__main__":
    register()