import bpy

def getArmatureObject(context):
    obj = context.active_object
    if obj:
        if obj.type == "ARMATURE":
            return obj
        elif obj.parent is not None and obj.parent.type == "ARMATURE":
            return obj.parent
        else:
            return None
        
def getArmatureAction(context):
    arm = getArmatureObject(context)
    return getattr(arm.animation_data, "action", None)

def getDsplAction(context):
    arm = getArmatureObject(context)
    return getattr(arm.dspl, "pose_library", None)

def getPoseLib(context):
    arm = getArmatureObject(context)
    pose_library_dspl = getDsplAction(context)
    pose_library_action = getArmatureAction(context)
    if pose_library_dspl:
        return pose_library_dspl
    elif pose_library_action and not pose_library_dspl:
        return pose_library_action
    else:
        return None
