# SPDX-FileCopyrightText: 2021-2023 Blender Foundation
#
# SPDX-License-Identifier: GPL-2.0-or-later

"""
Pose Library - GUI definition.
"""

import bpy
from . import common

# Test Panel
class DATA_PT_TestPanel(bpy.types.Panel):
    bl_label = "Damn Simple Tests"
    bl_id = "DATA_PT_TestPanel"
    bl_space_type = 'VIEW_3D'
    bl_region_type = 'UI'
    bl_category = 'Pose'

    def draw(self, context):
        testing_layout = self.layout
        testing_layout1 = testing_layout.row()
        testing_layout1.operator("dspl.test", text="Test")
        testing_layout1.operator("dspl.test2", text="Test2")
        testing_layout1.operator("dspl.test3", text="Test3")
        testing_layout1.operator("dspl.test4", text="Test4")


def register():
    from bpy.utils import register_class
    register_class(DATA_PT_TestPanel)

def unregister():
    from bpy.utils import unregister_class
    unregister_class(DATA_PT_TestPanel)
