bl_info = \
	{
		"name" : "Damn Simple Pose Library",
		"author" : "jackie",
		"version" : (4, 1, 0),
		"blender" : (3, 0, 0),
		"description" : "woah",
		"category" : "Object Data",
	}


from typing import List, Tuple

_need_reload = "operators" in locals()
from . import gui, keymaps, operators, conversion, common

if _need_reload:
    import importlib

    gui = importlib.reload(gui)
    common = importlib.reload(common)
    keymaps = importlib.reload(keymaps)
    operators = importlib.reload(operators)
    conversion = importlib.reload(conversion)

import bpy

addon_keymaps: List[Tuple[bpy.types.KeyMap, bpy.types.KeyMapItem]] = []





# Register classes
def register() -> None:
    gui.register()
    operators.register()
    keymaps.register()


# Unregister classes
def unregister() -> None:
    keymaps.unregister()
    operators.unregister()
    gui.unregister()

