# Init
bl_info = \
	{
		"name" : "Damn super Simple Tests",
		"author" : "jackie",
		"version" : (4, 1, 0),
		"blender" : (3, 0, 0),
		"description" : "woah",
		"category" : "Object Data",
	}

import bpy
import math
from DamnSimplePoseLibrary import common

# Test Panel
class DATA_PT_TestPanel(bpy.types.Panel):
    bl_label = "Damn Simple Tests"
    bl_id = "DATA_PT_TestPanel"
    bl_space_type = 'VIEW_3D'
    bl_region_type = 'UI'
    bl_category = 'Pose'

    def draw(self, context):
        testing_layout = self.layout
        testing_layout1 = testing_layout.row()
        testing_layout1.operator("dspl.test", text="Test")
        testing_layout1.operator("dspl.test2", text="Test2")
        testing_layout1.operator("dspl.test3", text="Test3")
        testing_layout1.operator("dspl.test4", text="Test4")

# Test ops
class testOp(bpy.types.Operator):
    bl_idname = "dspl.test"
    bl_label = "Test1"
    bl_options = {'REGISTER', 'UNDO'}
    bl_description = "what"

    def execute(self, context):
        print("")
        print("test1")
        print("")

        def viewFrom(screen):
            """
            :param screen:
            :return: the "first" area in the specified screen that is a 3D view.
            """
            for obj in screen.areas:
                if (obj.type == 'VIEW_3D'):
                    return obj
            return None
        
        def wonk(factor):
            return 50*(2*math.sqrt(factor) - math.sqrt(2))
        
        
        v3d = viewFrom(bpy.context.screen)
        r3d = v3d.spaces[0].region_3d
        
        header_height = v3d.regions[0].height
        render_aspect = bpy.context.scene.render.resolution_x / bpy.context.scene.render.resolution_y
        window_aspect = v3d.regions[7].width / v3d.regions[7].height
        
        header_height = v3d.regions[0].height
        render_aspect = bpy.context.scene.render.resolution_x / bpy.context.scene.render.resolution_y
        window_aspect = v3d.regions[7].width / v3d.regions[7].height
        
        print("Header height: " + str(header_height))
        print("Render aspect: " + str(render_aspect))
        print("Window aspect: " + str(window_aspect))
        print("Window dim X: " + str(v3d.regions[7].width) + " Y: " + str(v3d.regions[7].height))
        print("Camera offset X: " + str(r3d.view_camera_offset.data.view_camera_offset[0]) + " Y: " + str(r3d.view_camera_offset.data.view_camera_offset[1]) + " Zoom: " + str(r3d.view_camera_offset.data.view_camera_zoom))
        
        def calcZoom(dimx, dimy):
            aspect = dimx / dimy if dimy != 0 else 1
            min_dim = min(dimx, dimy)
            zoom = 20 * math.log2(min_dim / 256)
            return zoom
        
        def calcZoom2(dimx, dimy):
            aspect = dimx / dimy if dimy != 0 else 1
            min_dim = min(dimx, dimy)
            zoom = 20 * math.log2(min_dim / 256)
            return zoom
        
        print("Test zoom: " +  str(calcZoom2(v3d.regions[7].width, v3d.regions[7].height)))

        if window_aspect < render_aspect:
            bpy.ops.view3d.view_center_camera()
            if v3d.regions[5].width > 1:
                r3d.view_camera_zoom = r3d.view_camera_zoom - 1
                r3d.view_camera_offset[0] = 0.01
                # r3d.view_camera_zoom = wonk2(window_aspect/render_aspect)
        elif  render_aspect < window_aspect:
            bpy.ops.view3d.view_center_camera()
            r3d.view_camera_zoom = r3d.view_camera_zoom - 1
            r3d.view_camera_offset[1] = 0.006


        return {'FINISHED'}

class testOp2(bpy.types.Operator):
    bl_idname = "dspl.test2"
    bl_label = "Test2"
    bl_options = {'REGISTER', 'UNDO'}
    
    def viewFrom(self, screen):
        """
        :param screen:
        :return: the "first" area in the specified screen that is a 3D view.
        """
        for obj in screen.areas:
            if (obj.type == 'VIEW_3D'):
                return obj
        return None
    
    def execute(self, context):
        print("")
        print("test2")
        print("")

        v3d = self.viewFrom(bpy.context.screen)
        r3d = v3d.spaces[0].region_3d

        bpy.ops.view3d.view_center_camera()

        r3d.view_camera_zoom = r3d.view_camera_zoom - 1
        r3d.view_camera_offset[1] = 0.006

        return {'FINISHED'}

class testOp3(bpy.types.Operator):
    bl_idname = "dspl.test3"
    bl_label = "Test3"



    def execute(self, context):
        print("")
        print("test3")
        print("")


        print("Pose Center")
        print("Index")
        print(common.searchPoseMarker(context, posename="Center", type="index"))
        print("Frame")
        print(common.searchPoseMarker(context, posename="Center", type="frame"))
        tempobj = common.searchPoseMarker(context,  posename="Center", type="marker")
        print ("Name:" + tempobj.name + " Frame:" + str(tempobj.frame) + " Index:" + str(common.searchPoseMarker(context, posename="Center", type="index")))

        
        # self.protectLooseLibs()


       #  bpy.ops.render.render(use_viewport=True)
       # bpy.ops.render.render(use_viewport=True)
       # bpy.ops.image.clipboard_copy()


        return {'FINISHED'}

class testOp4(bpy.types.Operator):
    bl_idname = "dspl.test4"
    bl_label = "Test4"
    # target_obj: bpy.props.StringProperty()

    def viewFrom(self, screen):
        """
        :param screen:
        :return: the "first" area in the specified screen that is a 3D view.
        """
        for obj in screen.areas:
            if (obj.type == 'VIEW_3D'):
                return obj
        return None

    def setCamtoBorder(self, context):

        print("woah")
        v3d = self.viewFrom(bpy.context.screen)
        r3d = v3d.spaces[0].region_3d

        header_height = v3d.regions[0].height
        render_aspect = bpy.context.scene.render.resolution_x / bpy.context.scene.render.resolution_y
        window_aspect = v3d.regions[7].width / v3d.regions[7].height
        
        header_height = v3d.regions[0].height
        render_aspect = bpy.context.scene.render.resolution_x / bpy.context.scene.render.resolution_y
        window_aspect = v3d.regions[7].width / v3d.regions[7].height

        print("Header height: " + str(header_height))
        print("Render aspect: " + str(render_aspect))
        print("Window aspect: " + str(window_aspect))
        print("Window dim X: " + str(v3d.regions[7].width) + " Y: " + str(v3d.regions[7].height))
        print("Camera offset X: " + str(r3d.view_camera_offset.data.view_camera_offset[0]) + " Y: " + str(r3d.view_camera_offset.data.view_camera_offset[1]) + " Zoom: " + str(r3d.view_camera_offset.data.view_camera_zoom))



        if window_aspect < render_aspect:
            print("tall")
            bpy.ops.view3d.view_center_camera()
        elif  render_aspect < window_aspect:
            print("Wide")
            bpy.ops.view3d.view_center_camera()

    def adjust_camera_view(self, context):
        # Get the current scene
        scene = bpy.context.scene

        # Get the current render settings
        resolution_x = scene.render.resolution_x
        resolution_y = scene.render.resolution_y
        border_min_x = scene.render.border_min_x
        border_max_x = scene.render.border_max_x
        border_min_y = scene.render.border_min_y
        border_max_y = scene.render.border_max_y

        # Calculate the center of the render area
        
        center_x = ((border_max_x - border_min_x) * resolution_x) / 2
        # print(center_x)
        #center_x = border_min_x * resolution_x + render_width / 2
        center_y = ((border_max_y - border_min_y) * resolution_y) / 2
        # print(center_y)
        #center_y = border_min_y * resolution_y + render_height / 2

        left_edge =  resolution_x * border_min_x
        right_edge = resolution_x * border_max_x
        top_edge =  resolution_y * border_max_y
        bottom_edge = resolution_y * border_min_y
        print(left_edge)
        print(right_edge)        
        print(top_edge)
        print(bottom_edge)


        offset_x = border_min_x * .10
        offset_y = border_min_y * .10


        # Set the camera view to center on the render area
        bpy.ops.view3d.view_center_camera()

        # Adjust the camera offset to match the render area
        camera_offset = bpy.context.screen.areas[3].spaces[0].region_3d.view_camera_offset
        camera_offset[0] = offset_x
        camera_offset[1] = offset_y

        # Adjust the camera zoom to maintain a proper view
        # camera_zoom = bpy.context.screen.areas[3].spaces[0].region_3d.view_camera_zoom
        # You may need to adjust the zoom level based on your scene's requirements
        # For simplicity, let's just maintain the current zoom level

        print("Camera view adjusted to center on the render area.")

        print("")

    def execute(self, context):
        print("")
        print("test4")
        print("")

        if bpy.context.scene.render.use_border:
            self.adjust_camera_view(context)



        return {'FINISHED'}




            # bpy.ops.view3d.view_center_camera()
            # bpy.ops.view3d.zoom_camera_1_to_1()
            # bpy.ops.view3d.zoom_border(xmin=1, xmax=500, ymin=500, ymax=500)
            # if v3d.regions[5].width > 1:
            #     r3d.view_camera_zoom = r3d.view_camera_zoom - 1
            #     r3d.view_camera_offset[0] = 0.01
            #     # r3d.view_camera_zoom = wonk2(window_aspect/render_aspect)
                

            # bpy.ops.view3d.view_center_camera()
            # r3d.view_camera_zoom = r3d.view_camera_zoom - 1
            # r3d.view_camera_offset[1] = 0.006

classes = (
   testOp,
   testOp2,
   testOp3,
   testOp4
)

register, unregister = bpy.utils.register_classes_factory(classes)

def register():
    from bpy.utils import register_class
    register_class(DATA_PT_TestPanel)
    for cls in classes:
        register_class(cls)

def unregister():
    from bpy.utils import unregister_class
    unregister_class(DATA_PT_TestPanel)
    for cls in classes:
        unregister_class(cls)

if __name__ == "__main__":
    register()


# 
#  
#  /* -------------------------------------------------------------------- */
#  /** \name Frame Camera Bounds Operator
#   * \{ */
#  
#  static int view3d_center_camera_exec(bContext *C, wmOperator * /*op*/)
#  {
#    Depsgraph *depsgraph = CTX_data_ensure_evaluated_depsgraph(C);
#    Scene *scene = CTX_data_scene(C);
#    float xfac, yfac;
#    float size[2];
#  
#    View3D *v3d;
#    ARegion *region;
#    RegionView3D *rv3d;
#  
#    /* no nullptr check is needed, poll checks */
#    ED_view3d_context_user_region(C, &v3d, &region);
#    rv3d = static_cast<RegionView3D *>(region->regiondata);
#  
#    rv3d->camdx = rv3d->camdy = 0.0f;
#  
#    ED_view3d_calc_camera_border_size(scene, depsgraph, region, v3d, rv3d, size);
#  
#    /* 4px is just a little room from the edge of the area */
#    xfac = float(region->winx) / float(size[0] + 4);
#    yfac = float(region->winy) / float(size[1] + 4);
#  
#    rv3d->camzoom = BKE_screen_view3d_zoom_from_fac(min_ff(xfac, yfac));
#    CLAMP(rv3d->camzoom, RV3D_CAMZOOM_MIN, RV3D_CAMZOOM_MAX);
#  
#    WM_event_add_notifier(C, NC_SPACE | ND_SPACE_VIEW3D, v3d);
#  
#    return OPERATOR_FINISHED;
#  }
#  
#  void VIEW3D_OT_view_center_camera(wmOperatorType *ot)
#  {
#    /* identifiers */
#    ot->name = "Frame Camera Bounds";
#    ot->description = "Center the camera view, resizing the view to fit its bounds";
#    ot->idname = "VIEW3D_OT_view_center_camera";
#  
#    /* api callbacks */
#    ot->exec = view3d_center_camera_exec;
#    ot->poll = view3d_camera_user_poll;
#  
#    /* flags */
#    ot->flag = 0;
#  }
#  
#  /** \} */